# chaos/tools: outils développés pour LXD

## backup

Ce dépôt contient l'ensemble des éléments utilisés pour sauvegarder mon infrastructure :

  - la configuration réseau (`/etc/network/interfaces` ou `/etc/systemd/network`)
  - la configuration du pare-feu (`/etc/nftables.conf`)
  - la configuration du démon de découverte automatique de voisins IPv6 (`/etc/ndppd.conf`)
  - la configuration de wireguard (`/etc/wireguard/wg0.conf`)
  - la configuration de LXD (`lxd init --dump`)
  - le profile par défaut de LXD (`lxc profile show default`)
  - l'ensemble des conteneurs LXC (`lxc export --instance-only`)

Le script fonctionne actuellement sur Debian Bullseye (11) et est amené à évoluer en fonction de mes besoins.

Chaque éléments sauvegardé ne l'est que si il existe, cela permet d'exécuter le script sur des serveurs ne disposant pas de LXD par exemple.

Il est possible d'exclure des conteneurs de la sauvegarde en créer le fichier `doNotBackup.list` à la racine du dossier `backup`. Ce fichier doit contenir un nom de conteneur par ligne.

La rétention des sauvegardes est de neuf jours.

## balance-containers

Ce script permet soit de :
  - créer une liste des conteneurs en fonction de leur hôte
  - déplacer les conteneurs présents sur la machine où le script est lancé
  - répartir les conteneurs en fonction de la liste précédemment générée

## Post-déploiement

Les quelques lignes suivantes me permettent de déployer ce dépôt sur les hôtes LXC :

```base
cd /tmp &&\
git clone ssh://gitea@git.ykn.fr:12393/chaos/tools.git &&\
sudo mv tools /opt/ &&\
cd /opt/tools/backup &&\
sudo ln -s /mnt/pumbaa/backup/containers/ .; \
sudo ln -s /mnt/pumbaa/backup/$(hostname)/ ./host; \
ls -lah
```
